

#include "VISA_GPIB_manager.h"

#ifndef  _Agilent_34401A_GPIB_22_dot_h_
#define  _Agilent_34401A_GPIB_22_dot_h_

 VISA_GPIB_manager Agilent_34401A_GPIB_22_controller;

int  Agilent_34401A_GPIB_22_INIT(void);
int  Agilent_34401A_GPIB_22_transmitt_message(char Interface_Message[]);//Only conduit to machine
int  Agilent_34401A_GPIB_22_receive_message  (char Interface_Message[]);//Only conduit from machine



//****************** UNIQUE HARDWARE INTERFACE OBJECTS ********************** 
int  Agilent_34401A_GPIB_22_device_ID;//USED BY NI488 to ID Agilent meter SEE int Agilent_34401A_GPIB_22_INIT(void)


double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_CURRENT();
double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_Voltage();

double long Agilent_34401A_GPIB_22_Fetch_DUT_AC_CURRENT();
double long Agilent_34401A_GPIB_22_Fetch_DUT_AC_Voltage();
double long Agilent_34401A_GPIB_22_Fetch_DUT_FREQ();



/********************** Agilent_34401A_GPIB_22_transmitt_message ************************
  
   This funcion is the only conduit to the equipment.  You place what ever 
SCPI code that you want in the "char Interface_Message[]" 

  This simplifies the hardware interface in the sense that you only need to place
 hardware IO code in one place.  

  @params
  char Interface_Message[] This MUST be a NULL terminated message that 
you pass to the equipment.

  @returns 

  the return message depends on the I/O software that you  use.  I have no way
  a priori to know this.

******************************************************************************/


int Agilent_34401A_GPIB_22_transmitt_message(char Interface_Message[])
{
   int Error_Message=0;// Only feedback mechanism 

   //************* UNIQUE CLIENT HARDWARE CODE BELOW HERE ***************

    unsigned long  Message_Strlen;
  
	Message_Strlen = (unsigned long) strlen(Interface_Message);


  Agilent_34401A_GPIB_22_controller.Transmitt_a_char_array_to_GPIB(Interface_Message,Message_Strlen);



   //************* UNIQUE CLIENT HARDWARE CODE ABOVE HERE ***************
  return Error_Message;
}




/************************* Agilent_34401A_GPIB_22_receive_message  *********************

  This funcion is the only conduit from the equipment.  
  
    
	This simplifies the hardware interface in the sense that you only need 
to place IO hardware code in one place.  

  @params
  char Interface_Message[] Thisis  a NULL terminated message that 
you receive from the equipment.

  @returns 

  The return message depends on the I/O software that you  use.  I have no way
  a priori to know this.




*******************************************************************************/





int Agilent_34401A_GPIB_22_receive_message  (char Interface_Message[])
{
  int Error_Message=0;// Only feedback mechanism 


  unsigned long Number_of_chars_in_message=0;
   //************* UNIQUE CLIENT HARDWARE CODE BELOW HERE ***************


  Agilent_34401A_GPIB_22_controller.Receive_a_char_array_from_GPIB(Interface_Message,Number_of_chars_in_message);



  Interface_Message[Number_of_chars_in_message]='\0';


   //************* UNIQUE CLIENT HARDWARE CODE ABOVE HERE ***************

  return Error_Message;
}




/*************************  Agilent_34401A_GPIB_22_INIT ****************************

 This is a collection of functions that you use to initialise the  hardware 
 
    
	   >>>>>AND<<<<<< 
	   
		
the software interface software. Examples of this are GPIB settings or RS232
settings, file pointers ect.

@returns 

  The return message depends on the I/O software that you  use.  I have no way
  a priori to know this.


**********************************************************************/
int Agilent_34401A_GPIB_22_INIT(void)
{
  int  Error_Message=0;
  int  Number_of_Bytes;
  char Interface_Message[256];
  int  Bytes_dispatched_to_RS232_conduit;


  //Agilent_34401A_GPIB_22_controller.Report_avalible_VISA_interfaces();


 Agilent_34401A_GPIB_22_controller.Designate_GPIB_address("GPIB0::22::INSTR");

 //************* UNIQUE CLIENT HARDWARE CODE ABOVE HERE ***************



     //****** RESET AGILENT METER ***********************
	  strcpy_s(Interface_Message,define_256_chars,"*RST \n");//Reset machine
   	  Number_of_Bytes = strlen(Interface_Message);
	  Bytes_dispatched_to_RS232_conduit = strlen(Interface_Message);
      Agilent_34401A_GPIB_22_transmitt_message( Interface_Message);


      //****** PURGE STATUS REGISTER ***********************
	  strcpy_s(Interface_Message,define_256_chars,"*CLS \n");
   	  Number_of_Bytes = strlen(Interface_Message);
	  Bytes_dispatched_to_RS232_conduit = strlen(Interface_Message);
      Agilent_34401A_GPIB_22_transmitt_message( Interface_Message);


	  //**************** DISPLAY MESSAGE TO USER  Visual feed back *****************
	  strcpy_s(Interface_Message,define_256_chars,"DISPLAY:TEXT 'AGILENT_OK'\n");
	  Bytes_dispatched_to_RS232_conduit = strlen(Interface_Message);
	  Agilent_34401A_GPIB_22_transmitt_message( Interface_Message);
	  //************* __________________________________________ ******************* 
      


	   //**************** DISPLAY MESSAGE TO USER  Visual feed back *****************
	  strcpy_s(Interface_Message,define_256_chars,"*IDN?\n");
	  Bytes_dispatched_to_RS232_conduit = strlen(Interface_Message);
	  Agilent_34401A_GPIB_22_transmitt_message( Interface_Message);
	  Agilent_34401A_GPIB_22_receive_message  (Interface_Message);
	  
	   fprintf(stderr,"Agilent_34401A=%s",Interface_Message);
	   //getchar();
	  //************* __________________________________________ ******************* 
      



  return Error_Message;

};//END int Agilent_34401A_GPIB_22_INIT(void)





/******************** Agilent_34401A_GPIB_22_Fetch_DUT_DC_CURRENT **************************
  
    I want to configure the Agilent meter to measure 20mA with as much precision
as possible.  

 I need to instruct the meter to use as high as precision as possible. 

   Use the phrase "MEASure:CURRent:DC? 0.100, 0.0000001"  the last term adjusts
 the precision.  I have forgotten what this means. The smaller the number,
 the higher the precision.  The meter also requires longer time If you want an
 explanation,then consult the Agilent literature that I have furnished with 
 this program.


 ********************_________________________________ **************************/

 double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_CURRENT()
 {

  double long Measured_DUT_current;


  char Interface_Message[1000];
 
   

   //****** EXTRACT MEASUREMENT ************************
   strcpy(Interface_Message,"MEASure:CURRent:DC? 0.100, 0.000001");
   Agilent_34401A_GPIB_22_transmitt_message(Interface_Message);
   Agilent_34401A_GPIB_22_receive_message  (Interface_Message);

 
   Measured_DUT_current=Char_array_to_double (Interface_Message );
 
  return  Measured_DUT_current;
 };//END  double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_CURRENT()








/******************** Agilent_34401A_GPIB_22_Fetch_DUT_AC_CURRENT **************************
  
  This is a perfideous measurement!! You can NOT reset (*RST) the machine just prior
 to  requesting this measurement.  If you observe abnormally high reported AC current 
 measurements, then search through your code for a reset or a change of configuration.


 ********************_________________________________ **************************/

 double long Agilent_34401A_GPIB_22_Fetch_DUT_AC_CURRENT()
 {

  double long Measured_DUT_current;


  char Interface_Message[1000];
 
   

   //****** EXTRACT MEASUREMENT ************************
   
   // Instruct the Agilent to ignore other request while
   // measuring the current.  THis measurement requires 
   // 3 to 4 seconds.
   strcpy(Interface_Message,"*WAI");//MEAS:CURR:AC? 1,1E-6
   Agilent_34401A_GPIB_22_transmitt_message(Interface_Message);

   // Actual request
   strcpy(Interface_Message,"MEAS:CURR:AC? 0.1,1E-6");//MEAS:CURR:AC? 1,1E-6
   Agilent_34401A_GPIB_22_transmitt_message(Interface_Message);
    
  
  

   Agilent_34401A_GPIB_22_receive_message  (Interface_Message);//Where are the results?

   


    Measured_DUT_current=Char_array_to_double (Interface_Message );
 
  return  Measured_DUT_current;
 };//END  double long Agilent_34401A_Fetch_DUT_ADC_CURRENT()












/******************** Agilent_34401A_GPIB_22_Fetch_DUT_DC_Voltage **************************
  
    I want to configure the Agilent meter to measure 0 to 10V with as much precision
as possible.  

   I have forgotten what this means.  If you want an explanation,
 then consult the Agilent literature that I have furnished with this program.


 ********************_________________________________ **************************/

 double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_Voltage()
 {

  double long Measured_DUT_voltage;


  char Interface_Message[1000];
 
   

   //****** EXTRACT MEASUREMENT ************************
   strcpy(Interface_Message,"MEASure:VOLT:DC? 10.00, 0.00001");
   Agilent_34401A_GPIB_22_transmitt_message(Interface_Message);
   Agilent_34401A_GPIB_22_receive_message  (Interface_Message);

   Measured_DUT_voltage=Char_array_to_double (Interface_Message );
 
  return  Measured_DUT_voltage;
 };//END  double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_Voltage()





/******************** Agilent_34401A_GPIB_22_Fetch_DUT_AC_Voltage **************************
  
    I want to configure the Agilent meter to measure AC voltage.  This is done 
    as a simple check for DUT oscillation.  This is a crude test. Snivel, Snivel.

 ********************_________________________________ **************************/

 double long Agilent_34401A_GPIB_22_Fetch_DUT_AC_Voltage()
 {

  double long Measured_DUT_voltage;


  char Interface_Message[1000];
 
   

   //****** EXTRACT MEASUREMENT ************************
   strcpy(Interface_Message,"MEASure:VOLT:AC? 10, 0.00001");
   Agilent_34401A_GPIB_22_transmitt_message(Interface_Message);
   Agilent_34401A_GPIB_22_receive_message  (Interface_Message);

   Measured_DUT_voltage=Char_array_to_double (Interface_Message );
 
  return  Measured_DUT_voltage;
 };//END  double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_Voltage()






 /******************** Agilent_34401A_GPIB_22_Fetch_DUT_FREQ **************************
  
   

 ********************_________________________________ **************************/

 double long Agilent_34401A_GPIB_22_Fetch_DUT_FREQ()
 {

  double long DUT_MEAS_FREQ;


  char Interface_Message[1000];
 
   

   //****** EXTRACT MEASUREMENT ************************//VOLTage:DC:NPLC?


   strcpy(Interface_Message,"FREQuency:APERture 1");//Set to MAX =>1 second

   Agilent_34401A_GPIB_22_transmitt_message(Interface_Message);

   strcpy(Interface_Message,"MEAS:FREQ?");

   Agilent_34401A_GPIB_22_transmitt_message(Interface_Message);
   Agilent_34401A_GPIB_22_receive_message  (Interface_Message);
   //fprintf(stderr,"Interface_Message=%s\n",Interface_Message);

   DUT_MEAS_FREQ=Char_array_to_double (Interface_Message );
 
  return  DUT_MEAS_FREQ;
 };//END  double long Agilent_34401A_GPIB_22_Fetch_DUT_DC_Voltage()




#endif