

/*****************  REQUIRED READING *******************************

   Required reference material:


  
     NI-VISA
	 Programmer Reference Manual
     February 1996 Edition
     Part Number 321073A-01


Web Link
http://www.ni.com/pdf/manuals/321073a.pdf

*****************  REQUIRED READING ********************************/





/* WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING 


  1)  You MUST down load the "NI-VISA" frame work from National Instruments.  
      Search for "visa" on Ni's web site.  This is a 750 megabyte
      (+7.5E+8 bytes) file.

  2) You also need 30 minutes or so to install the software. ZZZZZ

  3) After instalation you must exercise the NI software before all of 
    the myriad of *.dll, *.lib, *.obj, and *.wtf files are copied to 
	the correct directory. 

 4)   Before you down load the NI-VISA software, you must have legal 
     authority to do so. 


 WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING  WARNING */
/*




Instuctions for "visa32.lib" 

 1)  Use your computer's search function to find  where the following files are
    hidden: "oleaut32.lib uuid.lib odbc32.lib odbccp32.lib"


     On my machine this is located in

     "C:\Program Files\Microsoft Visual Studio\VC98\Lib

      Place a copy of "visa32.lib"  in this directory.



  2) Alternatively, try adding the following lines in the header file.
    
	#pragma comment( lib, "visa32.lib" ) (Windows ONLY)
	

 
If you use unix, then you must find the analogus linux VISA files.

     If you want to use  unix, then you might want to make a rodent 
sacrifice to Baal Moloch in Valley of Hinnom otherwise you must 
endure the "RTFM" key board trolls.

************************************************************************/


#include <windows.h>
#include <stdio.h>


#include "visa.h"                   
#include "visatype.h"               
#pragma comment( lib, "visa32.lib" )//Only works for Microsoft Development Studio/


#ifndef _VISA_GPIB_manager_dot_h_
#define _VISA_GPIB_manager_dot_h_

#pragma message("\n ************* ------------------------- ***********************  \n")
#pragma message("\n **            _VISA_GPIB_manager_dot_h_                        *  \n")
#pragma message("\n **                October 10, 2014                            *  \n")
#pragma message("\n ************* _________________________ ***********************  \n \n \n")




/***************  COMPILER strcpy_s appeasement ********
  Need to use a # define to appease  strcpy_s
******************  ___________________ ***************/
#ifndef   define_256_chars  
#define   define_256_chars  (256)
#endif


class VISA_GPIB_manager
{
     



public:

        VISA_GPIB_manager();
        ~VISA_GPIB_manager();

    
       

        int      Report_avalible_VISA_interfaces();

	    ViStatus Designate_GPIB_address(char Requested_GPIB_Address[]);

		ViStatus Transmitt_a_byte_array_to_GPIB(unsigned char GPIB_message_byte_array[], unsigned long &Number_of_bytes_in_message );
        ViStatus Transmitt_a_char_array_to_GPIB(char          GPIB_message_char_array[], unsigned long &Number_of_chars_in_message );
        ViStatus Receive_a_byte_array_from_GPIB(unsigned char GPIB_message_byte_array[], unsigned long &Number_of_bytes_in_message );
        ViStatus Receive_a_char_array_from_GPIB(char          GPIB_message_char_array[], unsigned long &Number_of_chars_in_message );    
   



private:
	  
	   
       unsigned long _pvt_Actual_Bytes_Transmitted;   // The actual number of bytes transmitted to GPIB
	   unsigned long _pvt_Actual_Bytes_Received;      // The actual number of bytes transmitted to GPIB
	   unsigned char _pvt_GPIB_INT_flag;              // = 0XFF when GPIB is initilised OK 

	   
	   ViSession     _pvt_VISA_Resorce_ID;               // This must be set prior to summons to any of the                               
	   ViSession     _pvt_Default_Resource_Manager;      // Default Resource manager;

	   
	   char          _pvt_GPIB_address[define_256_chars];//
	   char          _pvt_BELL_array[define_256_chars];  // an array of three char(7);
  
	   char          _pvt_char_YN;

       FILE          *_pvt_Report_VISA_INTRFACE_FILE_pntr;// Writes the engineering file

       errno_t       _pvt_File_Open_Error;                // Magical varible: Abra Cadabra
	  
	 
	   void          _pvt_Acknowlege_Message();
       void          _pvt_Designate_GPIB_address_Error_Message();

       int           _pvt_VISA_Resorce_ID_Error_Message( );//ERROR TESTING


       unsigned char _pvt_unsigned_char_array_to_char_array(unsigned char  Source_unsigned_char_array[], char Destination_char_array[], unsigned int Array_Length);
	   unsigned char _pvt_char_array_to_unsigned_char_array(char Source_char_array[], unsigned char Destination_unsigned_char_array[], unsigned int Array_Length);


        


};//END class VISA_GPIB_manager

































  VISA_GPIB_manager::VISA_GPIB_manager()
  {  
    _pvt_GPIB_INT_flag =0X00;// Device has not been intialised
	strcpy_s(_pvt_GPIB_address,250,"NOT_INITIALISED_YET");

	_pvt_BELL_array[0]=(char) 7;
	_pvt_BELL_array[1]=(char) 7;
	_pvt_BELL_array[2]=(char) 7;
	_pvt_BELL_array[3]='\0';
	   
   };//ENDVISA_GPIB_manager::VISA_GPIB_manager()




    VISA_GPIB_manager::~VISA_GPIB_manager()
    {
	  viClose (_pvt_VISA_Resorce_ID);         //Close VISA session.
	  viClose (_pvt_Default_Resource_Manager);//Close VISA session.
    
	};//END  VISA_GPIB_manager::~VISA_GPIB_manager
                

     /***************  Designate_GPIB_address ***********************

      You must specify the address of the equipment that you want to 
    control.   There are two parameters that you must specify:

	 Parameter:     Translation:

	 Board_ID       This is the board number of the GPIB controller
	                board.  Most of the time this is either "1" or
				    "0"

     GPIB_address   This is the address of the machine itself. You 
	                usually can change this by poking buttons on 
					the equipment face plate.


    The address is formulated by 


     "GPIB( Board_ID )::( GPIB_address )::INSTR"

	 Example:

	 So a board address of "0" and an instrument address is 12
	 the full address is:

	 "GPIB0::12::INSTR"


     DO NOT waste much time memorising this!

    
	Use : " Report_avalible_VISA_interfaces();" 



	The reported results are foumulated in the correct format.  


     ***************  ___________________ ************************/


	  ViStatus  VISA_GPIB_manager::Designate_GPIB_address(char Requested_GPIB_Address[])
	 {
         
		 static ViStatus VISA_status;


          _pvt_GPIB_INT_flag =0X00;
      
          VISA_status = viOpenDefaultRM (&_pvt_Default_Resource_Manager);  

		  if (0!=VISA_status)
		  {
			  _pvt_Designate_GPIB_address_Error_Message();
			  return VISA_status;
		  }
		 
		  strcpy_s(_pvt_GPIB_address,100,Requested_GPIB_Address);

          VISA_status = viOpen (_pvt_Default_Resource_Manager, _pvt_GPIB_address, VI_NULL,VI_NULL, &_pvt_VISA_Resorce_ID); // 

		  if (0!=VISA_status)
		  {
		    _pvt_VISA_Resorce_ID_Error_Message( );
			return VISA_status;
			 
		  }

           _pvt_GPIB_INT_flag =0XFF;

		   return VISA_status;
	 };//END  ViStatus  VISA_GPIB_manager::Designate_GPIB_address(char Requested_GPIB_Address[])



 
   /************   VISA_GPIB_manager::Report_avalible_VISA_interfaces  ******************


      Use this function when you want to observe all of the avalible VISA interfaces on 
	your computer. A text file is generated that you can copy and paste your desired 
	interface ID directly in to:  

	"Designate_GPIB_address(char Requested_GPIB_Address[])".



	Other interfaces are reported, but this class does not use them.

    This is a realtively slow function. You might need to wait up to 60 seconds (or more)
for results.  The results are reported to ""Avalible_VISA_Interfaces_Report.txt"


   *************  __________________________________________________  *******************/


	  	   int VISA_GPIB_manager::Report_avalible_VISA_interfaces()
	   {
		   
		   
		 //****************** Varible Declaration Zone *************************
         // char Arrays
      
		 // VISA Varibles 
         static char instrDescriptor[VI_FIND_BUFLEN];
         static ViUInt32 Num_VISA_Resources;
         static ViFindList findList;
         static ViSession defaultRM, instr;
         static ViSession MY_Instument;
         static ViStatus _pvt_status;

		  FILE *VISA_interfaces_report_FILE_pntr;



		
	     printf("\n\n\n''Report_avalible_VISA_interfaces'' invoked. \n\n Need to wait for up to 60seconds.\n\n\n\n");
	     Sleep(500);
   
		 /* First we will need to open the default resource manager. */
         _pvt_status = viOpenDefaultRM (&defaultRM);
         if (_pvt_status < VI_SUCCESS)
        {
          printf("******************** ERROR ALERT!  ***********************\n");
	      printf("*                                                        *\n");
	      printf("* Could not open a session to the VISA Resource Manager! *\n");
	      printf("*                                                        *\n");
	      printf("******************** ERROR ALERT!  ***********************\n");
	      printf("%s\n",_pvt_BELL_array);
	      printf("\n\n\n");
	      _pvt_Acknowlege_Message();
          exit (EXIT_FAILURE);
         }  

         /*
         * Find all the VISA resources in our system and store the number of resources
         * in the system in numInstrs.  Notice the different query descriptions a
         * that are available.

           Interface         Expression
           --------------------------------------
           GPIB              "GPIB[0-9]*::?*INSTR"
           VXI               "VXI?*INSTR"
           GPIB-VXI          "GPIB-VXI?*INSTR"
           Any VXI           "?*VXI[0-9]*::?*INSTR"
           Serial            "ASRL[0-9]*::?*INSTR"
           PXI               "PXI?*INSTR"
           All instruments   "?*INSTR"
           All resources     "?*"  
           a*/


		 
     

    //***************************** OPEN DEFAULT VISA OBJECT **********************************

    _pvt_status = viFindRsrc (defaultRM, "?*", &findList, &Num_VISA_Resources, instrDescriptor);
    if (_pvt_status < VI_SUCCESS)
    {

	   printf("******************** ERROR ALERT!  ***********************\n");
	   printf("*                                                        *\n");
	   printf("*  A default VISA Resource Manager can not be opened     *\n");
	   printf("*                                                        *\n");
	   printf("*            VISA Resource Manager puked!                *\n");
	   printf("*                                                        *\n");
	   printf("******************** ERROR ALERT!  ***********************\n");
	   printf("%s\n",_pvt_BELL_array);
	   printf("\n\n\n");
	 _pvt_Acknowlege_Message();
	 
      viClose (defaultRM);
	  return 0;

   }
   //***************************** OPEN DEFAULT VISA OBJECT **********************************
   
	// File_Open_Error = fopen_s(&_pvt_Engineering_file_writer,Reserved_File_Name_Array, "w");

	 _pvt_File_Open_Error = fopen_s(&VISA_interfaces_report_FILE_pntr,"Avalible_VISA_Interfaces_Report.txt", "w+"); 


	 if ((0!=_pvt_File_Open_Error)||(NULL==VISA_interfaces_report_FILE_pntr))
	 {
		  _pvt_char_YN='n';
		  while ('y'!=_pvt_char_YN)
		  {
		   printf("\n\n\n");
           printf("******************** ERROR ALERT!  ***********************\n");
	       printf("*                                                        *\n");
	       printf("*  ''Report_avalible_VISA_interfaces'' puked on you.     *\n");
	       printf("*                                                        *\n");
		   printf("* Can not open ''Avalible_VISA_Interfaces_Report.txt''   *\n");
		   printf("*                                                        *\n");
		   printf("*                                                        *\n");
		   printf("*   You might need to restart your machine to purge the  *\n");
		   printf("* abandoned file pointers.                               *\n");
		   printf("*                                                        *\n");
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n", _pvt_BELL_array);
	       printf("\n\n\n");
	       printf("Tap 'y' to acknowlege this message.");
		   _pvt_char_YN = getchar();
		  }
		  return -1;//Error

	 };//END if ((0!=_pvt_File_Open_Error)||(NULL==VISA_interfaces_report_FILE_pntr))

	 fclose(VISA_interfaces_report_FILE_pntr);


	 //********************************** FIND ANY INTERFACE  **********************************
	 //
     //  This section finds all of the VISA resources.  This is important since some ports do not
     // have a predefined protocol. An example of this is the RS 232 serial port. These ports do
     // not respond to an "*IDN?\n" request if the protocol if the protocol adjustments are not
     // set proporly. 
 
 
     Num_VISA_Resources++;//Accomadates the next while statement
  
     while (--Num_VISA_Resources) /* stay in this loop until we find all instruments */
    {
	
      if (_pvt_status < VI_SUCCESS) 
      {   /* did we find the next resource? */
		 
		  
           printf("******************** ERROR ALERT!  ***********************\n");
	       printf("*                                                        *\n");
	       printf("*            VISA Resource Manager puked!                *\n");
	       printf("*                                                        *\n");
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("%s\n", _pvt_BELL_array);
	        _pvt_Acknowlege_Message();
         
       viClose (defaultRM);
	  

         
      } 

	  fopen_s(&VISA_interfaces_report_FILE_pntr,"Avalible_VISA_Interfaces_Report.txt", "a");

      fprintf(VISA_interfaces_report_FILE_pntr,"VISA Interface(%i)=%s\n",Num_VISA_Resources,instrDescriptor);
	  printf("VISA Interface(%i)=%s\n",Num_VISA_Resources,instrDescriptor);
	  fclose(VISA_interfaces_report_FILE_pntr);


	 
	 //Resource_ID_Num++;
    
      _pvt_status = viFindNext (findList, instrDescriptor);  /* find next desriptor */ 
   }    /* end while */
   //********************************END FIND ANY INTERFACE ******************************/

	 system("Avalible_VISA_Interfaces_Report.txt");

       
 
         return 0;
	};//int VISA_GPIB_manager::Report_avalible_VISA_interfaces()




	/**************  Transmitt_a_byte_array_to_GPIB **************************

    
	Entity:                    Translation:

	GPIB_message_byte_array               This is an array of bytes that you want to 
	                            transmitt to the GPIB interface. 

    Number_of_bytes_in_message		This is the number of bytes that you WANT 
	                             to  send to the interface.

									When the function returns, the value of 
								 Number_of_bytes_in_message is the actual number 
								 of bytes that were sent.
	                       
	**************  ____________________________ ****************************/

	

  ViStatus VISA_GPIB_manager::Transmitt_a_byte_array_to_GPIB(unsigned char GPIB_message_byte_array[], unsigned long &Number_of_bytes_in_message )
  {
			

     static ViStatus GPIB_status;       //Returns status from VISA functions 0 if OK

	 unsigned long Actual_Write_Count;
	  
    // Check for intilisation
			
	 if (0XFF!=_pvt_GPIB_INT_flag)
	 {
        _pvt_VISA_Resorce_ID_Error_Message();
	    return -1;

	 }
			
     GPIB_status   = viWrite (_pvt_VISA_Resorce_ID, (ViBuf)GPIB_message_byte_array, Number_of_bytes_in_message, &Actual_Write_Count);//VI_Status

	 Number_of_bytes_in_message = Actual_Write_Count;
			
	 if (0!=GPIB_status)
	 {
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
	        printf("*            ''Transmitt_a_byte_array_to_GPIB'' puked!   *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("\n\n\n");
	        printf("Tap ''y'' key to acknowlege this message.\n");
            _pvt_char_YN = getchar();
			 return -1;
	   }

        

	return GPIB_status;
	           	
	 };//END    ViStatus VISA_GPIB_manager::Transmitt_a_byte_array_to_GPIB









  	/**************  Transmitt_a_char_array_to_GPIB **************************

    
	Entity:                     Translation:

	GPIB_message_char_array               An array of charss that you want to 
	                             transmitt to the GPIB interface. 

    Number_of_chars_in_message    The number of chars that you WANT to 
	                             send to the interface. 

								 When the function returns, the value of
								 "Number_of_chars_in_message" is the number
								 of chars that were actually sent.
	                          
	**************  ____________________________ ****************************/

     ViStatus VISA_GPIB_manager::Transmitt_a_char_array_to_GPIB( char GPIB_message_char_array[], unsigned long & Number_of_chars_in_message )
	 {
			

      static ViStatus GPIB_status;       //Returns status from VISA functions 0 if OK


	   unsigned long Actual_Write_Count;

	  unsigned char Ausgang_BYTE_array[500];
	  
	    // Check for intilisation
		if (0XFF!=_pvt_GPIB_INT_flag)
		{
             _pvt_VISA_Resorce_ID_Error_Message();
			 return -1;

		}


        _pvt_char_array_to_unsigned_char_array(GPIB_message_char_array, Ausgang_BYTE_array, ((unsigned int )Number_of_chars_in_message));
			
        GPIB_status   = viWrite (_pvt_VISA_Resorce_ID, (ViBuf)Ausgang_BYTE_array, Number_of_chars_in_message, &Actual_Write_Count);//VI_Status

		Number_of_chars_in_message = Actual_Write_Count;


			
	   if (0!=GPIB_status)
		{
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("*                                                        *\n");
	       printf("*            ''Transmitt_a_char_array_to_GPIB'' puked!   *\n");
	       printf("*                                                        *\n");
	       printf("******************** ERROR ALERT!  ***********************\n");
	       printf("\n\n\n");
	       printf("Tap ''y'' key to acknowlege this message.\n");
           _pvt_char_YN = getchar();
		   return -1;
	     }


        

			return GPIB_status;
	           	
		 };//END    ViStatus VISA_GPIB_manager::Transmitt_a_byte_array_to_GPIB





     /****************** Receive_a_byte_array_from_GPIB ****************************

    Entity:                      Translation:

	"GPIB_message_byte_array"           The array of bytes where you expect to recieve 
	                            the GPIB results. 
								
								WARNING!!!!!!
								This array pointer must accomadate at least 500 bytes.

    "Number_of_bytes_in_message"  When the fucntion returns, the value of 
	                              "Number_of_bytes_in_message" is the actual number
     							  of bytes in your results.


	 ****************** ______________________________ *****************************/




         ViStatus VISA_GPIB_manager::Receive_a_byte_array_from_GPIB(unsigned char GPIB_message_byte_array[], unsigned long &Number_of_bytes_in_message )
		 {
          	
            unsigned long      MAX_read_count;    // This is the number of bytes written to GPIB
            static   ViStatus  GPIB_status;       //Returns status from VISA functions 0 if OK

			// Check for intilisation
			if (0XFF!=_pvt_GPIB_INT_flag)
			{
             _pvt_VISA_Resorce_ID_Error_Message();
			 return -1;
			}
			


			MAX_read_count = Number_of_bytes_in_message;
			if (500>MAX_read_count)
			{

			  MAX_read_count = 500;
			                       //   There is a trap here.  If you assign an unsufficiently large number for
			                       // the maximum expected bytes, then you might lose some data!
			}


            GPIB_status = viRead (_pvt_VISA_Resorce_ID, (ViBuf)GPIB_message_byte_array, MAX_read_count, &Number_of_bytes_in_message);


			if (0!=GPIB_status)
			{
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
	        printf("*            ''Receive_a_byte_array_from_GPIB'' puked!          *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("\n\n\n");
	        printf("Tap ''y'' key to acknowlege this message.\n");
            _pvt_char_YN = getchar();
			 return -1;
			}

		
           return GPIB_status;
		 };//END  ViStatus VISA_GPIB_manager::Receive_a_byte_array_from_GPIB





		 
   
     /****************** Receive_a_char_array_from_GPIB ****************************

    Entity:                      Translation:

	"GPIB_message_char_array"           The array of chars where you expect to recieve 
	                             the GPIB results. 
								WARNING!! This array pointer must accomadate
								at least 500 chars!!!

    "Number_of_bytes_in_message"     When the fucntion returns, the value of 
	                              "Number_of_bytes_in_message" is the actual number
     							  of chars in your results.
	 ****************** ______________________________ *****************************/




		 ViStatus VISA_GPIB_manager::Receive_a_char_array_from_GPIB( char GPIB_message_char_array[], unsigned long &Number_of_chars_in_message )
		 {
          	
            unsigned long      MAX_read_count;    // This is the number of bytes written to RS232
            static   ViStatus  GPIB_status;       //Returns status from VISA functions 0 if OK

			unsigned char GPIB_BYTE_array[500];

			// Check for intilisation
			if (0XFF!=_pvt_GPIB_INT_flag)
			{
             _pvt_VISA_Resorce_ID_Error_Message();
			 return -1;
			}
			
          

		    MAX_read_count = Number_of_chars_in_message;
			if (500>MAX_read_count)
			{

			  MAX_read_count = 500;
			                       //   There is a trap here.  If you assign an unsufficiently large number for
			                       // the maximum expected bytes, then you might lose some data!
			}


            GPIB_status = viRead (_pvt_VISA_Resorce_ID, (ViBuf)GPIB_BYTE_array, MAX_read_count, &Number_of_chars_in_message);


			if (0!=GPIB_status)
			{
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("*                                                        *\n");
	        printf("*        ''Receive_a_byte_array_from_GPIB'' puked!       *\n");
	        printf("*                                                        *\n");
	        printf("******************** ERROR ALERT!  ***********************\n");
	        printf("\n\n\n");
	        printf("Tap ''y'' key to acknowlege this message.\n");
            _pvt_char_YN = getchar();
			 return -1;
			}

			_pvt_unsigned_char_array_to_char_array(GPIB_BYTE_array, GPIB_message_char_array, ((unsigned int)Number_of_chars_in_message));
		
			GPIB_message_char_array[Number_of_chars_in_message]='\0';
           return GPIB_status;
		 };//END  ViStatus VISA_GPIB_manager::Receive_a_char_array_from_GPIB








	   void VISA_GPIB_manager::_pvt_Acknowlege_Message()
	   {
		   
        _pvt_char_YN='n';
		while ('y'!=_pvt_char_YN)
		{
	      printf("Tap the 'y' and a 'return' key to acknowlege this message......");
		  _pvt_char_YN = (char) getchar();
		}
		   
		  return;//Nothing

	   };//END VISA_RS232_Manager::_pvt_Acknowlege_Message()




	void  VISA_GPIB_manager::_pvt_Designate_GPIB_address_Error_Message()
	{// Generic error message for SetAttribute_Error_Check
	
		_pvt_char_YN ='n';
		while ('y'!=_pvt_char_YN)
		{
			 system("cls");
	         printf("******************** ERROR ALERT!  ***********************\n");
	         printf("*                                                        *\n");
	         printf("*       Non valid result from  ''viOpenDefaultRM''       *\n");
	         printf("*                                                        *\n");
	         printf("*         VISA_GPIB_manager will now puke on you.        *\n");
			 printf("*                                                        *\n");
			 printf("*                                                        *\n");
	         printf("******************** ERROR ALERT!  ***********************\n");
			
	         printf("%s",_pvt_BELL_array);
	
	         printf("\n\n\n");
	         printf("Tap ''y'' key to acknowlege this message.\n");
             _pvt_char_YN = getchar();
		}
	         //cin.get();
	};//END VISA_GPIB_manager::_pvt_Designate_GPIB_address_Error_Message()







	   int  VISA_GPIB_manager::_pvt_VISA_Resorce_ID_Error_Message( )//ERROR TESTING
	   {
		//********************************************************************
	     //  This function is summoned when some attempts to use any of these *
	     // classes without initiliseing "_pvt_VISA_Resorce_ID"                    *
	     //********************************************************************

		   if (0X00==_pvt_GPIB_INT_flag)//Original value is bogus
		   {
			system("cls");

	     
	     

             _pvt_char_YN ='n';
		    while ('y'!=_pvt_char_YN)
		    {
			 system("cls");
	         printf("******************** ERROR ALERT!  ***********************\n");
	         printf("*                                                        *\n");
	         printf("*            _pvt_VISA_Resorce_ID is not intialised!      *\n");
	         printf("*                                                        *\n");
			 printf("*   The GPIB addres that you furnished:                 *\n");
			 printf("*       %s*\n",_pvt_GPIB_address );
			 printf("*                                                        *\n");
			 printf("*  might not be the correct format!                      *\n");
			 printf("*                                                        *\n");
			 printf("*                                                        *\n");
			 printf("* An example of a corrrect GPIB address is :             *\n");
			 printf("*                                                        *\n");
			 printf("*              ''GPIB0::22::INSTR''                      *\n");
		     printf("*                                                        *\n");
			 printf("*                                                        *\n");
			 printf("*  USE    ''Report_avalible_VISA_interfaces()''          *\n");
			 printf("*                                                        *\n");
	         printf("*           VISA_GPIB_manager will now puke on you.      *\n");
	         printf("*                                                        *\n");
	         printf("******************** ERROR ALERT!  ***********************\n");
			
	         printf("%s",_pvt_BELL_array);
	
	         printf("\n\n\n");
	         printf("Tap ''y'' key to acknowlege this message.\n");
             _pvt_char_YN = getchar();
		     }

               

			  //Report_avalible_VISA_interfaces()
			return -1;//ERROR code

		   }
	   
        return +1;// OK test code

	   }; //END  VISA_GPIB_manager::_pvt_VISA_Resorce_ID_Error_Message 





     unsigned char  VISA_GPIB_manager::_pvt_unsigned_char_array_to_char_array(unsigned char  Source_unsigned_char_array[], char Destination_char_array[], unsigned int Array_Length)
	 {
        unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_char_array[byte_index] = (char) Source_unsigned_char_array[byte_index];
		 }

        return reply_message;
	 };//END VISA_GPIB_manager::_pvt_unsigned_char_array_to_char_array



	unsigned char  VISA_GPIB_manager::_pvt_char_array_to_unsigned_char_array(char Source_char_array[], unsigned char Destination_unsigned_char_array[], unsigned int Array_Length)
	{

		unsigned char reply_message=0;
		unsigned int   byte_index;

		 for (byte_index=0;byte_index<Array_Length;byte_index++)
		 {
          Destination_unsigned_char_array[byte_index] = (unsigned char) Source_char_array[byte_index];
		 }

        return reply_message;
	};//END VISA_GPIB_manager::_pvt_char_array_to_unsigned_char_array

		  




#endif 



/************* LEGAL CYA ************************************************
	
1)  (I/we/us) make no expressed warranties or implied warranties 
   what-so-ever on the fitness or merchantability of this software for 
   any purpose.

2)   By using this software, you accept any and all liability and risk 
   associated with the use of this software.

3)  This software may NEVER be used in any shape form or 
    fashion that will result in: 
   
    A) Personal injury
    B) Economic damage
    C) Criminal activity
    D) Any circumstance that might enable a plaintifs lawyer to
	   sue (I/we/us) for criminal or civil penalties.

       
4)  Any use of this software is contingent on the indisputable fact 
   that anyone who uses this software accepts this software "AS-IS".

5)  Any re-transmission of this software MUST contain ALL of the 
   legal CYA text in the original unaltered form.  
************* LEGAL CYA *************************************************/